unit Unit1;

interface

uses
  math,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,smackw32, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Smk:HSmack;
    Fbmp:Tbitmap;
    procedure PlayToEnd;
  end;

var
  Form1: TForm1;

implementation

uses Types;

{$R *.dfm}

{-------------------------------------------------------------------------------
    Very clumsy play method, but this is an example of Smacker, not
    multithreading.

    I suggest wrapping the playing in a thread...

    Note that if you want to play upon 8bit bitmaps, you must match
    its palette with HSMACKER.Palette
-------------------------------------------------------------------------------}
procedure TForm1.PlayToEnd;
var
  info:windows.bitmap;
begin
   // our buffer to receive uncompressed smacker data
   fbmp := TBitmap.create;
   fbmp.Width := smk.Width;
   fbmp.Height:= smk.Height;
   fbmp.PixelFormat:=pf16bit; // 16bit!
   fbmp.Canvas.Brush.color:=0;
   fbmp.Canvas.FillRect(fbmp.Canvas.ClipRect);

   GetObject(fbmp.Handle,sizeof(info),@info); // get info holding datapointer

   // tell smacker that future decompressing happens on our buffer
   SmackToBuffer(smk,0,0,
                 smk.Width*2, // pitch = width * bits/8
                 smk.Height,
                 info.bmBits,
                 SMACKBUFFER565 OR
                 SMACKBUFFERREVERSED);// Bitmaps draws bottom-up, so we reverse

   // loop 'till end of movie
   repeat
     // decompress frame
     SmackDoFrame(Smk);
     // Draw buffer to our canvas
     paintbox1.Canvas.StretchDraw(paintbox1.ClientRect,Fbmp);
     // busy waiting until next frame. (controlled by the framerate)
     while SmackWait(smk) do;
     // display progress
     statusbar1.Panels[1].Text :=
        'Frame: '+inttostr(smk.CurrentFrame)+'/'+inttostr(smk.TotalFrames);
     Application.ProcessMessages;

     // get ready for next frame.
     SmackNextFrame(smk);
   until smk.CurrentFrame >=smk.TotalFrames-1;

   fbmp.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  S:string;
begin
 Caption := 'Delphi Smacker - By Lars Peter Christiansen';

 if  SmackSoundUseDirectSound(nil) then
   s := 'DirectSound'
 else if SmackSoundUseWin then
   s := 'WaveOut'
 else S:='No sound';


 statusbar1.Panels[0].text:='Smackw32.dll '+getSmackerVersion+' ('+s+')';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  C:TSMACKCURSOR;
begin

  Smk := SmackOpen(pchar(edit1.text),
                   SMACKOPEN_TRACKS OR
                   SMACKOPEN_NEEDVOLUME OR
                   SMACKOPEN_NEEDPAN,
                   0);
  if smk=nil then
    begin
      caption:='ERROR NIL';
      exit;
    end;

  // hide cursor
  C := SmackCheckCursor(Panel1.handle,panel1.ClientRect);
  PlayToEnd;
  // show cursor. (peekaboo)
  SmackRestoreCursor(C);
end;

end.
